"ifMUD"

Part 0 - Game and Platform Information

When play begins (this is the print introduction rule):
	say fixed letter spacing;
	say "************************************************************************[line break]**                                                                    **[line break]**                          Welcome to ifMUD!                         **[line break]**                                                                    **[line break]************************************************************************[paragraph break]";
	say variable letter spacing;
	say "Based on your IP address, we have identified you as the player '[player]'. For your convenience, you will be logged in automatically."

After printing the banner text:
	say "[one of][paragraph break]*** Message of the Day ***[paragraph break]Welcome to day 1 of the public beta. For help with MUD commands, type 'help'. To disconnect, type 'quit'. If you need assistance or find a bug, or if you want to create an account, come to my office and let me know.[paragraph break]*** Known Issues ***[paragraph break]Some testers have reported trouble with our server's output buffering. Please bear with us as we work to resolve this. If it seems like nothing's happening, your MUD client probably doesn't handle line mode -- try pressing enter to flush the buffer.[paragraph break]--Stan[paragraph break][or][stopping]"

Chapter 1 - Standard Metadata

The story headline is "An interactive conversation".
The story creation year is 2008.
The story genre is "MUD".
The story description is "It's ifMUD, and all your friends are here!".

Include (- Serial "080401"; -).

Use full-length room descriptions.
Use memory economy.
Use no scoring.

The player is in Dorm A. The player is neuter.

When play begins (this is the no command prompt rule): change the command prompt to "".

The mud uptime is a number that varies. [The mud uptime is 15720 [in 15 second units].]

[Set the mud uptime based on the real time clock.]
When play begins (this is the initialize uptime rule):
	if the real time clock is available, change the mud uptime to the real time in quarts;
	otherwise change the mud uptime to 15720.

Report requesting the story file version (this is the extended version rule):
	let N be the number of connected people;
	say "MUD version: 1.0 b2 (build=318 DEBUG=1 MAXPLAYERS=64 AUTOLOGIN=1)[line break]MUD uptime: [mud uptime as a short time]. Open sockets: [if a random chance of 1 in 10 succeeds][N + 1][otherwise][N][end if]."

Section 1 - Debugging Helpers (not for release)

[We want a prompt for debugging.]
The no command prompt rule is not listed in the when play begins rulebook.

Chapter 2Z - Communicating with the Server (for Z-machine only)

Include (-
Array serv_id buffer 16;
Array serv_word --> 1;

[ GetServWord name  idstr rv;
	@output_stream 3 serv_id;
	print (I7_string) name;
	@output_stream -3;
	if (serv_id-->0 > 16) serv_id->1 = 16;
	idstr = serv_id + 1;
	@restore serv_word WORDSIZE idstr -> rv;
	if (rv) return serv_word-->0;
	return -1;
]; ! end of GetServWord -);

To decide which number is server register (register name - text): (- GetServWord({register name}) -).

To decide whether real time clock is available: decide on whether or not server register "timeq" is not -1.

To decide which number is the real time in quarts: decide on server register "timeq".

Chapter 2G - Communicating with the Server (for Glulx only)

To decide whether real time clock is available: decide no.

To decide which number is the real time in quarts: decide on -1.

Part 1 - Mudlike Framework

[On a real MUD, time doesn't stand still for typos. We may not have timed input support in our target environment, but at least we can make something happen every time the player hits Enter.]

The every input rules are a rulebook.

[For Stan's plot, we want timers to advance even when the player is fumbling around trying to respond to his page.]
The timed events rule is not listed in the turn sequence rules.
The timed events rule is listed in the every input rules.

Include (- Replace Keyboard; -) before the library.

Include (-
[ Keyboard  a_buffer a_table  nw i w w2 x1 x2;
    DisplayStatus();

  .FreshInput;

    ! Save the start of the buffer, in case "oops" needs to restore it
    ! to the previous time's buffer

    for (i=0 : i<64 : i++) oops_workspace->i = a_buffer->i;

    ! In case of an array entry corruption that shouldn't happen, but would be
    ! disastrous if it did:

    #Ifdef TARGET_ZCODE;
    a_buffer->0 = INPUT_BUFFER_LEN;
    a_table->0 = 15;  ! Allow to split input into this many words
    #Endif; ! TARGET_

    ! Print the prompt, and read in the words and dictionary addresses

    #ifdef NI_BUILD_COUNT; I7_Prompt(); #endif;
    #ifndef NI_BUILD_COUNT; L__M(##Prompt); #endif;
    AfterPrompt();
    #IfV5;
    DrawStatusLine();
    #Endif; ! V5
    KeyboardPrimitive(a_buffer, a_table);
    #Ifdef TARGET_ZCODE;
    nw = a_table->1;
    #Ifnot; ! TARGET_GLULX
    nw = a_table-->0;
    #Endif; ! TARGET_

ProcessRulebook( (+every input rules+) );

    ! If the line was blank, get a fresh line
    if (nw == 0) {
        #ifdef NI_BUILD_COUNT;
        i = etype; etype = BLANKLINE_PE;
        BeginActivity(PARSERERROR_ACT);
           if (ForActivity(PARSERERROR_ACT) == false) L__M(##Miscellany,10);
           EndActivity(PARSERERROR_ACT);
        etype = i;
        #ifnot;
        L__M(##Miscellany, 10);
        #endif; ! NI_BUILD_COUNT
        jump FreshInput;
    }

    ! Unless the opening word was "oops", return
    ! Conveniently, a_table-->1 is the first word in both ZCODE and GLULX.

    w = a_table-->1;
    if (w == OOPS1__WD or OOPS2__WD or OOPS3__WD) jump DoOops;

    if (a_buffer->WORDSIZE == COMMENT_CHARACTER) {
        #Ifdef TARGET_ZCODE;
        if ((HDR_GAMEFLAGS-->0) & 1 || xcommsdir)
                                           L__M(##Miscellany, 54);
        else                               L__M(##Miscellany, 55);
        #Ifnot; ! TARGET_GLULX
        if (gg_scriptstr || gg_commandstr) L__M(##Miscellany, 54);
        else                               L__M(##Miscellany, 55);
        #Endif; ! TARGET_

        jump FreshInput;
    }

    #IfV5;
    ! Undo handling

    if ((w == UNDO1__WD or UNDO2__WD or UNDO3__WD) && (nw==1)) {
        #ifdef PREVENT_UNDO;
        print "The use of UNDO is forbidden in this game.^";
        jump FreshInput;
        #ifnot;
        if (turns == START_MOVE) {
            L__M(##Miscellany, 11);
            jump FreshInput;
        }
        if (undo_flag == 0) {
            L__M(##Miscellany, 6);
            jump FreshInput;
        }
        if (undo_flag == 1) jump UndoFailed;
        #Ifdef TARGET_ZCODE;
        @restore_undo i;
        #Ifnot; ! TARGET_GLULX
        @restoreundo i;
        i = (~~i);
        #Endif; ! TARGET_
        if (i == 0) {
          .UndoFailed;
            L__M(##Miscellany, 7);
        }
        jump FreshInput;
        #endif; ! PREVENT_UNDO
    }
    #Ifdef TARGET_ZCODE;
    @save_undo i;
    #Ifnot; ! TARGET_GLULX
    @saveundo i;
    if (i == -1) {
        GGRecoverObjects();
        i = 2;
    }
    else  i = (~~i);
    #Endif; ! TARGET_
    just_undone = 0;
    #ifdef PREVENT_UNDO; undo_flag = 0; #endif;
    #ifndef PREVENT_UNDO; undo_flag = 2; #endif;
    if (i == -1) undo_flag = 0;
    if (i == 0) undo_flag = 1;
    if (i == 2) {
        RestoreColours();
        #Ifdef TARGET_ZCODE;
        style bold;
        #Ifnot; ! TARGET_GLULX
        glk($0086, 4); ! set subheader style
        #Endif; ! TARGET_
        print (name) location, "^";
        #Ifdef TARGET_ZCODE;
        style roman;
        #Ifnot; ! TARGET_GLULX
        glk($0086, 0); ! set normal style
        #Endif; ! TARGET_
        L__M(##Miscellany, 13);
        just_undone = 1;
        jump FreshInput;
    }
    #Endif; ! V5

    return nw;

  .DoOops;
    if (oops_from == 0) {
        L__M(##Miscellany, 14);
        jump FreshInput;
    }
    if (nw == 1) {
        L__M(##Miscellany, 15);
        jump FreshInput;
    }
    if (nw > 2) {
        L__M(##Miscellany, 16);
        jump FreshInput;
    }

    ! So now we know: there was a previous mistake, and the player has
    ! attempted to correct a single word of it.

    for (i=0 : i<INPUT_BUFFER_LEN : i++) buffer2->i = a_buffer->i;
    #Ifdef TARGET_ZCODE;
    x1 = a_table->9;  ! Start of word following "oops"
    x2 = a_table->8;  ! Length of word following "oops"
    #Ifnot; ! TARGET_GLULX
    x1 = a_table-->6; ! Start of word following "oops"
    x2 = a_table-->5; ! Length of word following "oops"
    #Endif; ! TARGET_

    ! Repair the buffer to the text that was in it before the "oops"
    ! was typed:

    for (i=0 : i<64 : i++) a_buffer->i = oops_workspace->i;
    Tokenise__(a_buffer,a_table);

    ! Work out the position in the buffer of the word to be corrected:

    #Ifdef TARGET_ZCODE;
    w = a_table->(4*oops_from + 1); ! Start of word to go
    w2 = a_table->(4*oops_from);    ! Length of word to go
    #Ifnot; ! TARGET_GLULX
    w = a_table-->(3*oops_from);      ! Start of word to go
    w2 = a_table-->(3*oops_from - 1); ! Length of word to go
    #Endif; ! TARGET_

    ! Write spaces over the word to be corrected:

    for (i=0 : i<w2 : i++) a_buffer->(i+w) = ' ';

    if (w2 < x2) {
        ! If the replacement is longer than the original, move up...
        for ( i=INPUT_BUFFER_LEN-1 : i>=w+x2 : i-- )
            a_buffer->i = a_buffer->(i-x2+w2);

        ! ...increasing buffer size accordingly.
        #Ifdef TARGET_ZCODE;
        a_buffer->1 = (a_buffer->1) + (x2-w2);
        #Ifnot; ! TARGET_GLULX
        a_buffer-->0 = (a_buffer-->0) + (x2-w2);
        #Endif; ! TARGET_
    }

    ! Write the correction in:

    for (i=0 : i<x2 : i++) a_buffer->(i+w) = buffer2->(i+x1);

    Tokenise__(a_buffer, a_table);
    #Ifdef TARGET_ZCODE;
    nw = a_table->1;
    #Ifnot; ! TARGET_GLULX
    nw = a_table-->0;
    #Endif; ! TARGET_

    return nw;
]; ! end of Keyboard -).

Chapter 1 - Familiar Commands

Section 1 - "lounge", "home", "toyshop", "xyzzy/plugh"

Teleporting to the lounge is an action applying to nothing. Understand "lounge" as teleporting to the lounge.

Check teleporting to the lounge when the player is in the lounge:
	say "You're already in the lounge, doofus." instead.

Carry out teleporting to the lounge:
	say "Just chatting your life away, right?";
	now the player is in the lounge.

Teleporting home is an action applying to nothing. Understand "home" as teleporting home.

Carry out teleporting home:
	say "You click your heels together. The slow pace like gnome, their snow plays lie cone, there's not place like home...";
	now the player is in Dorm A.

Teleporting to the toyshop is an action applying to nothing. Understand "toyshop" as teleporting to the toyshop.

Carry out teleporting to the toyshop:
	say "Playtime!";
	now the player is in the Toyshop.

Teleporting to the long hall is an action applying to nothing. Understand "xyzzy" or "plugh" as teleporting to the long hall.

Carry out teleporting to the long hall:
	say "You apply a great deal of concentration, and find yourself walking into another place.";
	now the player is in the Long Hall.

Going, teleporting to the lounge, teleporting home, teleporting to the toyshop, and teleporting to the long hall are traveling.

Section 2 - Chat and @-commands

After reading a command:
	let cmd be indexed text;
	let cmd be the player's command;
	if cmd matches the regular expression "^(<@;#>|p\b|page\b|wh\b|whisper\b)" begin;
		say "Permission denied.";
		reject the player's command;
	otherwise if cmd matches the regular expression "^(<':.>|say\b|emote\b|pose\b)";
		say "Old-style chat commands are not supported here. Please use ASK, TELL, or ANSWER, or type a player's name followed by a comma and the message ('inky, hello'). To speak to everyone in your location, try 'everyone, hello'.";
		reject the player's command;
	end if.

Understand "talk" or "talk to [text]" as a mistake ("To speak to a particular player, use their name and a comma, like 'inky, hello'. To speak to everyone nearby, try 'everyone, hello'.").

To decide if conversing: (- (scope_reason == TALKING_REASON) -).

_Everyone is a person. Understand "everyone" as _everyone when conversing.

After deciding the scope of the player, place _everyone in scope.

This is the new accessibility rule:
	if the noun is not _everyone, abide by the basic accessibility rule.

The new accessibility rule is listed instead of the basic accessibility rule in the action-processing rules.

Before answering someone (called the target) that:
	say "You say[if the target is not _everyone] (to [target])[end if], '[topic understood]'[line break][run paragraph on]".

Before asking someone (called the target) about:
	say "You ask[if the target is not _everyone] (of [target])[end if], '[topic understood]?'[line break][run paragraph on]".

Before telling someone (called the target) about:
	say "You say[if the target is not _everyone] (to [target])[end if], '[topic understood]'[line break][run paragraph on]".

Before asking someone (called the target) to try saying yes:
	try answering the target that "yes" instead.

Before asking someone (called the target) to try saying no:
	try answering the target that "no" instead.

After answering or asking or telling someone about when the noun is _everyone:
	if a random chance of 1 in 2 succeeds begin;
		let the observer be a random active mudder who observes the player;
		if the observer is a mudder begin;
			provoke a random response from the observer;
			stop;
		end if;
	end if;
	say "". [causes a line break when no one responds]

[Suppress messages like "There is no reply."]
The block asking rule is not listed in any rulebook.
The block telling rule is not listed in any rulebook.
The block answering rule is not listed in any rulebook.

Section 3 - Fake Unix commands

Understand "ls [text]" or "dir [text]" or "cd [text]" or "mkdir [text]" or "ls" or "dir" or "cd" or "mkdir" as a mistake ("Syntax Error. You're on ifMUD, remember?").

Section 4 - Requesting help

Requesting general help is an action applying to nothing. Understand "help" as requesting general help.

Carry out requesting general help:
	say "ifMUD Temporary Help System[paragraph break]The help system is not yet complete. In the meantime, try commands such as these:[paragraph break]WHO [italic type](to see the list of connected players)[roman type][line break]WHERE [italic type](to see where the other players are)[roman type][line break]FINGER ALEX [italic type](to learn more about a player)[roman type][line break]EVERYONE, I'M NEW HERE [italic type](talk to everyone)[roman type][line break]ALEX, TELL ME ABOUT YOURSELF [italic type](talk to one person)[roman type][line break]LOUNGE [italic type](teleport to the lounge)[roman type]"

Requesting help on is an action applying to one topic. Understand "help [text]" as requesting help on.

Carry out requesting help on:
	say "Sorry, there is no such help topic as ['][topic understood][']. Try just typing help."

Understand "faq" as a mistake ("http://diden.net/~maga/ifMUDfaq/").

Section 5 - "who" and "where"

Listing all players is an action applying to nothing. Understand "who" as listing all players.
Listing one player is an action applying to one visible thing. Understand "who [any person]" as listing one player.
Understand "who [text]" as a mistake ("No known player by that name.").

Locating all players is an action applying to nothing. Understand "where" as locating all players.
Locating one player is an action applying to one visible thing. Understand "where [any person]" as locating one player.
Understand "where [text]" as a mistake ("No known player by that name.").

Table of Who Players
player		conntime
a person		a number
with 49 blank rows.

A person can be marked for listing.

Carry out listing all players:
	display a who list for connected people.

Carry out listing one player:
	display a who list for people who are the noun.

To display a who list for (D - description):
	say fixed letter spacing;
	[ header ]
	choose a random row in the Table of Anagrams;
	change the doing string of the player to the anagram entry;
	say " User         On     Idle   [poll entry][line break]";
	[ connected players ]
	repeat through the Table of Who Players begin;
		blank out the whole row;
	end repeat;
	repeat with P running through members of D begin;
		choose a blank row in the Table of Who Players;
		change the player entry to P;
		change the conntime entry to the connection time of P;
	end repeat;
	sort the Table of Who Players in conntime order;
	repeat through the Table of Who Players begin;
		let P be the player entry;
		let the padded name be "[P]" padded to 13 characters;
		if the idle time of P is at least 240, say "*";
		otherwise say " ";
		if P is connected, say "[padded name][connection time of P as a short time]  [if P is the player]00m00[otherwise][idle time of P as a short time][end if]  [doing string of P]";
		otherwise say "[padded name][bracket]Not logged in; last login: [random last login time][close bracket]";
		say line break;
	end repeat;
	say "Uptime: [mud uptime as a short time]; pollster: Tomorrow; ";
	if listing all players, say "Users online: [number of filled rows in the Table of Who Players]";
	otherwise say "Users: [number of filled rows in the Table of Who Players]; Online: [number of connected people]";
	say "[line break]End of List.";
	say variable letter spacing.

Carry out locating all players:
	display a where list for connected people.

Carry out locating one player:
	display a where list for people who are the noun.

To display a where list for (D - description):
	say fixed letter spacing;
	[ header ]
	say "User        Location[line break]";
	[ connected players ]
	repeat through the Table of Who Players begin;
		blank out the whole row;
	end repeat;
	repeat with P running through members of D begin;
		choose a blank row in the Table of Who Players;
		change the player entry to P;
		change the conntime entry to the connection time of P;
	end repeat;
	sort the Table of Who Players in conntime order;
	repeat through the Table of Who Players begin;
		let P be the player entry;
		let the padded name be "[P]" padded to 12 characters;
		say "[padded name][if P is in an unimplemented room]Somewhere[otherwise if P is on-stage][location of P][otherwise]Nowhere[end if]";
		if P is disconnected, say "[line break][bracket]Not logged in[close bracket]";
		say line break;
	end repeat;
	say "Uptime: [mud uptime as a short time][line break]End of List.";
	say variable letter spacing.

To decide which number is (X - number) % (Y - number): (- ({X}%{Y}) -).

To say (N - number) as a short time:
	let quarts be N % 4;
	let minutes be N / 4;
	let hours be minutes / 60;
	let days be hours / 24;
	let hours be hours % 24;
	let minutes be minutes % 60;
	let seconds be (quarts * 15) plus a random number between 0 and 14;
	if days is at least 1 begin;
		say "[days as two digits]d[hours as two digits]";
	otherwise if hours is at least 1;
		say "[hours as two digits]h[minutes as two digits]";
	otherwise;
		say "[minutes as two digits]m[seconds as two digits]";
	end if.

To say (N - number) as two digits: if N is less than 10, say "0"; say N.

[ Anagrams for "won't be laughing". ]
Table of Anagrams
anagram			poll
"the gin bungalow"	"Favorite bar"
"Tubal Whine Gong"	"Favorite exotic instrument"
"wiggle bath noun"	"Linguistic TSD"
"bawl enough, Ting?"	"Link's whiny companion"
"hint: age blowgun"	"How to hunt an old monkey"
"bun heating glow"	"What's inside your toaster?"
"gunwale bong hit"	"Talk about the high seas!"
"wealth gun. bingo!"	"Your dream invention"
"whale boning gut"	"What IS a corset, anyway?"
"Hate Bulging Now"	"Favorite weight loss slogan"
"GNU Wheat Goblin"	"Vegan monsters go open source"
"Ganglion Web Hut"	"Favorite cybercafe/neurosurgery clinic"
"aging bowel hunt"	"Least favorite nursing home sport"
">ogle thawing nub"	"Stiffy Makane meets Frozen Cavegirl"
"lubing wet Hogan"	"Professional oil wrestling"

Section 6 - "finger"

Requesting the profile of is an action applying to one visible thing. Understand "finger [any person]" as requesting the profile of.

Carry out requesting the profile of:
	say fixed letter spacing;
	let padded name be "[noun]" padded to 30 characters;
	say "Login name: [padded name]In real life: [real name of the noun][line break]";
	if the noun is on-stage, let stomping grounds be "[location of the noun]";
	otherwise let stomping grounds be "Nowhere";
	let padded name be "[stomping grounds]" padded to 32 characters;
	say "Location: [padded name]Gender: [if the noun is neuter]Neuter[otherwise if the noun is male]Male[otherwise]Female[end if][line break]";
	if the noun is connected, say "Currently logged in.";
	otherwise say "Last login: [random last login time][line break]";
	say "No plan.";
	say variable letter spacing.

Understand "finger [text]" as a mistake ("Usage: finger player"). 

To say random last login time:
	if a random chance of 1 in 2 succeeds begin;
		let month be "Feb";
		let day be a random number between 20 and 29;
	otherwise;
		let month be "Mar";
		let day be a random number between 1 and 31;
	end if;
	say "[day as two digits]-[month]-08 ";
	let hour be a random number between 0 and 23;
	say "[hour as two digits]:";
	let minute be a random number between 0 and 59;
	say "[minute as two digits]:";
	let second be a random number between 0 and 59;
	say "[second as two digits]".

To decide which indexed text is (T - indexed text) padded to (N - number) characters:
	let length be the number of characters in T;
	while the length is less than N begin;
		let T be "[T] ";
		increase length by 1;
	end while;
	while the length is greater than N begin;
		replace character number (length) in T with "";
		decrease length by 1;
	end while;
	decide on T.

Section 7 - "quote"

Understand "quote [any person]" as a mistake ("No quotes available.").
Understand "quote [text]" as a mistake ("Unknown quote command.").

Chapter 2 - Familiar Output

Section 1 - Looking

A room can be hazy. A room is usually not hazy.

Carry out looking (this is the visible exits rule):
	if a room is adjacent to the location begin;
		say "Visible Exits: ";
		let comma-needed be false;
		repeat with thataway running through directions begin;
			if the room thataway from the location is a room (called the other room) begin;
				if comma-needed is true, say ", ";
				say "[if thataway is inside]in[otherwise if thataway is outside]out[otherwise][thataway][end if]";
				if the other room is not hazy, say " ([exit description of the other room])";
				let comma-needed be true;
			end if;
		end repeat;
		say line break;
	end if.

Describing an exit to is an object-based rulebook. The describing an exit to rules have default success.

To say exit description of (R - room):
	consider the describing an exit to rules for R.

Last describing an exit to for a room (called R): say "to [if R is implemented]the [end if][R]".

Section 2 - Checking the score

This is the new announce the score rule:
	let N be a random number between 1 and 5;
	if N is 1, say "You have achieved [a random number between 1 and 500] points out of a possible 500, giving you the rank of Lord of the Bananas.";
	if N is 2, say "If you wanted to score, what are you doing on ifMUD?";
	if N is 3, say "You have achieved a score of 23 out of a possible 150, giving you the rank of ifMUD player.";
	if N is 4, say "You have achieved a score oAf8f24$JT$h^*nl. This gives you the rank of [bracket]BUG[close bracket].";
	if N is 5, say "Your score is zero. There are no points. Go away, and leave me alone."

The new announce the score rule is listed instead of the announce the score rule in the carry out requesting the score rules.

Section 3 - Waiting

This is the new report waiting rule:
	let N be a random number between 1 and 7;
	if N is 1, say "Time passes.";
	if N is 2, say "When you wake up, George III has been overthrown.";
	if N is 3, say "True love waits. So do you.";
	if N is 4, say "Thirty-four pounds!";
	if N is 5, say "Zed's dead, baby. Zed's dead.";
	if N is 6, say "log: sawed.";
	if N is 7, say "Dot dot dot."

The new report waiting rule is listed instead of the standard report waiting rule in the report waiting rules.

Section 4 - Save, restore, restart, undo

Understand the command "save" as something new. Understand the command "restore" as something new. Understand the command "restart" as something new.

Messing with the game state is an action applying to nothing. Understand "save" or "restore" or "restart" as messing with the game state.

Check messing with the game state (this is the can't mess with the game state rule):
	say "Disk error. Cannot save, restore, restart, or undo." instead.

After reading a command when the player's command matches "undo":
	follow the can't mess with the game state rule;
	reject the player's command.

Section 5 - Parser errors

Rule for printing a parser error when the parser error is not a verb I recognise or the parser error is didn't understand:
	say "Not a valid command. Try typing [']help[']."

Rule for printing a parser error when the parser error is I beg your pardon: do nothing.

Instead of going nowhere, say "There's no obvious exit in that direction."

Chapter 3 - Unimplemented areas

A room can be implemented or unimplemented. A room is usually implemented.

Instead of going to an unimplemented room, say "Permission denied."

Chapter 4 - Players

A person has text called the real name. The real name of a person is usually "[item described]".

A person has text called the doing string. The doing string of a person is usually "".

[ Connection and idle times are tracked in 15 second steps. ]
A person has a number called connection time. A person has a number called idle time.

When play begins (this is the initialize timers for non-mudders rule):
	repeat with P running through connected people begin;
		if P is not a mudder and P is not the player begin;
			change the connection time of P to a random number between 1 and the mud uptime;
			change the idle time of P to a random number between 0 and the connection time of P;
		end if;
	end repeat.

To reset idle time for (P - person): now the idle time of P is 0.

A person can be connected or disconnected. A person is usually disconnected.

Every input (this is the update time counters rule):
	increase the mud uptime by 1;
	repeat with P running through connected people begin;
		increase the idle time of P by 1;
		increase the connection time of P by 1;
	end repeat;
	reset idle time for the player.

[ the player ]
Rule for printing the name of yourself: say "Guest".
Understand "guest" as yourself.
Yourself is connected.

Part 2 - ifMUD Locations

Chapter 1 - The Lounge and Its Toys

The lounge is a room.

When play begins (this is the select a lounge description rule):
	choose a random row in the Table of Lounge Descs;
	now the printed name of the lounge is the lounge name entry;
	now the description of the lounge is the lounge description entry.

Table of Lounge Descs
lounge name				lounge description
"Adventurer's Temporal Anomaly"		"Candles on the wood panelled walls seem to grow taller with each drip of wax. Four-dimensional maps are taped to nearly every surface - the clocks, the calendars, the TARDIS disguised as a trophy case in the corner. Time is plentiful. A small storage closet is yesterday."
"Adventurer's Lost Pig"			"Walls on fire but fire small, so still dark in here. Papers with writing thing on it everywhere: wall, ceiling, big box in corner. Many chairs but easier just sit on floor. Think hear faint oinking to north."
"Adventurer's 'c'"			"Candles on the wood-panelled walls burn perpetually in the comfortably dark atmosphere. Unstoppable forces press against almost every surface -- the walls, the ceiling, even the immovable trophy case in the corner. Energy is plentiful. A pile of anti-matter lies to the north."
"Adventurer's Non-Euclidean Lounge"	"Sideways candles on the wood-panelled floor creates a slightly perplexing atmosphere. Hand-drawn moebius strips are taped to nearly every surface -- the ceiling, the floor, but curiously not the east or western walls. Seating is plentiful, since the room appears to contain the entire universe. A small storage closet is to the ... north?"

Rule for describing an exit to the lounge: say "to the Adventurer's Lounge".

[TODO: add "z" exit.]

A spoiler room sign is here. The spoiler room sign has indexed text called the message. Understand "neon" as the spoiler room sign.

Instead of examining the spoiler room sign:
	if the message of the spoiler room sign is blank, say "This sign, for displaying the topic being discussed in the spoiler room, is currently blank.";
	otherwise say "The topic being discussed in the spoiler room is [message of the spoiler room sign]."

After printing the name of the spoiler room sign while listing contents of the lounge:
	if the message of the spoiler room sign is not "", say " (currently set to: [message of the spoiler room sign])".

Section 1 - The birthday calendar

The birthday calendar is a thing in the lounge, fixed in place. The description is "It's a calendar which lists ifMUD events, and @users['] birthdays.[line break]Obvious actions: read january, read february, read march, read april, read may, read june, read july, read august, read september, read october, read november, read december".

A month is a kind of value. The months are defined by the Table of Months.

Table of Months
month		picture
January		"a snow-encrusted monastery"
February		"an off-balance teddy bear"
March		"a playful wind-spirit"
April		"bleating lambs"
May		"a demijohn"
June		"an ivy-entwined Victorian manor"
July		"a stifling theatre"
August		"a meandering tortoise"
September	"a smiling, friendly Buddha"
October		"scary, shuffling mannequins"
November	"a scantily-clad, suggestively-posed Tracy Valencia"
December	"the Kaldecki Monument"

Consulting the calendar about is an action applying to one month. Understand "read [month]" as consulting the calendar about when the player can see the birthday calendar.

Carry out consulting the calendar about:
	say "You flip to [the month understood]. Below a picture of [the picture of the month understood], you see a listing of people's birthdays and other events:[line break]";
	if the month understood is April, say "   1: April Fool's Day[line break]";
	otherwise say "(None recorded for this month.)".

Section 2 - Headline news

Headline News is a thing in the lounge, fixed in place. The description is "Latest Headlines:[line break]
 [bracket]general[close bracket] Gunther: INKY EARLY[line break]
 [bracket]news[close bracket] Nathan: Tulane Cancels Fall Semester Due To Katrina[line break]
 [bracket]news[close bracket] ctate: Shooting Victim Apologizes to Vice President[line break]
 [bracket]obits[close bracket] ctate: Coretta Scott King[line break]
 [bracket]obits[close bracket] inky: Richard Pryor, Eugene McCarthy[line break]
 [bracket]general[close bracket] zarf: Wall Street Journal has IF article, Slashdot mentions it[line break]
 [bracket]news[close bracket] markm: President Bush to nominate White House counsel Harriett Miers to replace retiring Supreme Court Justice Sandra Day O'Connor[line break]
 [bracket]obits[close bracket] ctate: Don Adams, 'Secret Agent 86,' dead at 82.[line break]
 [bracket]news[close bracket] inky: Mike Brown resigns from FEMA[line break]
 [bracket]news[close bracket] mcp: Rehnquist Dies".

Section 3 - Tallies

A tally is a kind of thing. A tally is usually fixed in place. A tally has a number called the counter. A tally has text called the measured quantity.

To say banner for (T - tally):
	say fixed letter spacing;
	say "+---------[dashes for the measured quantity of T]---------+[line break]";
	say "| Current [measured quantity of T]: [counter of T padded out] |[line break]";
	say "+---------[dashes for the measured quantity of T]---------+";
	say variable letter spacing.

To say (N - number) padded out:
	say "0";
	if N < 10000, say "0";
	if N < 1000, say "0";
	if N < 100, say "0";
	if N < 10, say "0";
	say N.

To say dashes for (T - text):
	let N be the number of characters in T;
	repeat with X running from 1 to N begin;
		say "-";
	end repeat.

Understand "push [tally] button/buton" as pushing.

Instead of pushing a tally:
	increase the counter of the noun by 1;
	say "You push the button on [the noun], and the number increases to [counter of the noun]."

The unfunny joke tally is a tally in the lounge. The description is "This is a sign which shows the number of attempts at humor which have fallen flat. Push the button on it to increase the number.[line break][banner for the unfunny joke tally][line break]Obvious actions: push ujt button". The counter is 1255. The measured quantity is "unfunny joke tally". Understand "ujt" as the unfunny joke tally.

The typo tally is a tally in the lounge. The description is "This is a sign which shows the number of jokes that have been ruined by a typo. Push the button on it to increase the number.[line break][banner for the typo tally][line break]Obvious actions: push typo tally button, push tyop taly buton". The counter is 1769. The measured quantity is "jokes ruined". Understand "tyop" or "taly" or "tt" as the typo tally.

The literal usage tally is a tally in the lounge. The description is "Usages of common cliches or metaphorical expressions in situations where they are also literally true have been recorded by our tireless researchers things many times: [counter of the literal usage tally][line break][bracket]To use: push literal usage tally[close bracket]". The counter is 1. The measured quantity is "literal usages". Understand "lut" as the literal usage tally.

Section 4 - Miscellaneous lounge toys

The book is a thing in the lounge. The description is "It appears to be Sein und Zeit by Martin Heidegger."

The flying sausage is a thing in the lounge. The description is "It's Blitzen Sausage! Made with real reindeer! (and it can fly, too!)[line break]Obvious Actions: throw flying sausage".

Instead of dropping the flying sausage:
	say "You grab one end of the flying sausage and throw it! The greased meat squirts out of your hand and flies above you, just out of reach. It plays with you for a while, tempting you to grab its end link and chew. When you tire of the game, it flies over to the other side of the room, and lands in a heap.";
	now the flying sausage is in the location.

The trophy case is an enterable scenery container in the lounge. The description is "It's quite large really. Large enough to climb inside, even." Understand "big" or "box" as the trophy case.

Chapter 2 - The Closet

Closet is north of the lounge. "This is a small, dark, musty closet used for storage. There's barely enough room to turn around."

Rule for describing an exit to the closet: say "to the closet".

An ifMUD Christmas tree is here.
Some Christmas lights are here.
A Christmas Bill O'Reilly is here.
A thing called Nothing is here.
A thing called another banner is here.
Some trash is here.
A clamshell necklace is here.
The Newest Optimus Prime toy is here.
Some grilled cheese is here.
A ball of goo is here.
A thing called cold is here.
Some delicious ice cream is here.
An invisible corknut is here.
A slimy toad named Ivan is here.
The European standard banana is here. The indefinite article is "a".
A worm taco is here.
Erik Estrada is here.
Some greetings are here.
Some confetti is here.
Some festive celebratory music is here.
The Infocom feelies list is here.
A mystical sata cable of +12 connectivity is here.
An endless abyss is here.
A space vacuum is here.
A tip of his hat is here.
A banana is here.
The k00b is here.
A super-sekrit manual is here.
Some information is here.
A $2000 handbag is here. The printed name is "$2000 handbag you bought with cash". Understand "you/bought/with/cash" as the handbag.
Some Festivus shopping is here.
A huge pile of pancakes is here.
A New Year's Bill O'Reilly is here.
A shovel is here.
A thing called thing is here.
Some corn is here.
A cream pie is here.
DX Ditches his VHS Collection is here.
A stone is here.
An acorn is here.
A cute widdle pickable-uppable object of lurrrrv is here.
Some time zones are here.
A coke is here.
A thing called The Imperative Tense is here.
A burning torch is here.
A cork nut is here.
A bell is here.

Chapter 3 - The Long Hall

Long Hall is east of the lounge. "This room is brilliantly lit from all directions. In fact, it is unclear where the walls and ceiling end. Doorways lead to the east and west, and tunnels open up in most other directions. An archway stands at the south end of the hall, and stairs lead up and down."

Rule for describing an exit to the Long Hall when the player is in the Cavernous Cavern or the player is in the lounge: say "to the Long Hall and most of ifMUD".

A torch in a wall sconce is here. It is fixed in place. The description is "It seems surprisingly unnecessary given the fact that the room is already lit by magic ambient light fairies.  Of course, the only other reason anyone puts sconces anyplace nowadays is to be the opening mechanism for secret passages."

Instead of pulling the sconce:
	say "You pull down on the torch.  Just as if this was a Scooby-Doo cartoon, a
    section of wall pivots and you suddenly find yourself elsewhere.";
	now the player is in the dark oubliette;
	rule succeeds.

Pulling the sconce is traveling.

Chapter 4 - The dark oubliette (dead end)

The dark oubliette is a room. The printed name is "A dark oubliette". "A dank and dismal place, lit only by a thin shaft of light from a window high above you (which is what makes it an oubliette). A small pile of straw occupies one corner, and another is occupied by the skeleton of a former resident."

An escape ladder is here. The description is "This ladder has been placed here for your convenience."

Instead of climbing the escape ladder:
	now the player is in the Long Hall;
	rule succeeds.

Climbing the escape ladder is traveling.

Chapter 5 - Dorm A

Dorm A is below the Long Hall. "This is a very long room, lined with multi-tiered bunks. Flimsy partitions between the tiers may provide a modicum of privacy. These spartan living quarters could house hundreds, many of whom are sleeping here right now. A narrow staircase set in the north wall leads up."

Rule for describing an exit to Dorm A: say "to Dorm A".

Chapter 6 - The Cavernous Cavern (dead end)

Cavernous Cavern is south of the Long Hall. "This long, empty room may once have contained anything -- gold bars, crates of books, radioactive waste, even *people*, stacked up like lumber. Now, though, its emptiness makes it seem even larger than it really is. The south wall is marked up to look a little like the inside of a house, including a front door, but that quickly gives way to bare concrete and even chipped rock towards the north end. Aside from the doorway, archways also lead out to the north and east."

Rule for describing an exit to Cavernous Cavern: say "to a Cavernous Cavern".

East of the cavern is an unimplemented room with printed name "the auditorium".
South of the cavern is an unimplemented room with printed name "the outdoors and Edifice Towers".

Chapter 7 - The Round Room (dead end)

Round Room is north of the Long Hall. "This roughly circular room appears to have been carved from a light, chalky substance. Tunnels could potentially lead anywhere, but the main exits are clearly to the north and south."

Northeast of the Round Room is an unimplemented hazy room.
Northwest of the Round Room is an unimplemented hazy room.
Up from the Round Room is an unimplemented hazy room.
Down from the Round Room is an unimplemented hazy room.
Outside from the Round Room is an unimplemented hazy room.
Southwest from the Round Room is an unimplemented hazy room.
Southeast from the Round Room is an unimplemented hazy room.
West from the Round Room is an unimplemented hazy room.
North from the Round Room is an unimplemented room with printed name "the Cement Passage".

[TODO: add "elevator", "Bierzelt", "counterclockwise", and "sideways" exits.]

Poochy is a thing in the Round Room. The description is "A very cute puppy. It seems fuzzy and quite pettable.[line break]Obvious Actions: pet dog". Understand "dog" as Poochy.

Understand "pet [something]" as rubbing. Instead of rubbing Poochy, say "Poochy wags his tail and pants gently as you pet him."

Section 1 - The teleportation booth

A teleportation booth is in the Round Room. The description is "About the size of a telephone booth, this odd metal chamber has a door on the front. Above the door is a sign reading TELEPORTATION BOOTH. You can vaguely see shadows inside, through the small window set in the door, but you'd have to enter the booth to get a better view."

Instead of entering the booth:
	now the player is in the teleportation booth interior;
	rule succeeds.

Entering the booth is traveling.

The teleportation booth interior is a room with printed name "Teleportation Booth". "This room is relatively small, but it could hold a number of people if they were all willing to hold their breath. A monitor screen on one side of the room displays some potentially interesting text, and the keypad beside it appears to be of some interest."

Rule for describing an exit to the teleportation booth interior: say "into the teleportation booth".

Outside from the teleportation booth interior is the Round Room.

A monitor is scenery in the teleportation booth interior. It is fixed in place. The description is "The monitor displays several lines of some strange runic text, along with a series of hexadecimal numbers: 58595A5A5920504C55474820504C4F564552. Luckily, the bottom part of the display is in English, and reads [']Round Room, coordinates 031[']. The keypad is mostly labelled in the same runic script as most of the monitor, but one large red key is labelled [']TELEPORT[']." Understand "screen" or "text" or "interesting" or "potentially interesting" or "keypad" as the monitor.

A red key is part of the monitor. The description is "This is the only key on the keypad whose designation is clear. It says TELEPORT on it." Understand "teleport" or "button" as the red key.

Instead of pushing the red key:
	say "You push the TELEPORT button, and feel a slight spark when you do. Your vision momentarily blurs before returning to normal.";
	[ this actually goes nowhere on ifMUD, but that's boring and unexpected... ]
	now the player is in the Round Room;
	rule succeeds.

Pushing the red key is traveling.

Chapter 8 - The Coder's Tavern (dead end)

Coder's Tavern is east of the Long Hall. "This place is a mess. Cryptic manuals covered in circular coffee stains are strewn about the room. Notes, potato chips and soda bottles are everywhere. To the north, a dark stairway leads downwards."

Down from the Coder's Tavern is an unimplemented room with printed name "the Tavern's Cellar".

Before going north in the Coder's Tavern, try going down instead.

Chapter 9 - The Big Dig (dead end)

Big Dig is southwest of the Long Hall. "Rough-hewn tunnels surround you on all sides. It looks like more digging has been done here, although the original exit to the northeast is still visible. The room is lit be a single hole in the ceiling, and a ladder leads up to the hole."

A thing called the ladder is scenery in the Big Dig. The description is "A ladder leads up to a small hole in the ceiling. Sunlight shines down from from the hole." Understand "hole" as the ladder. Before climbing the ladder, try going up instead.

An archway is here. The description is "This rough-hewn archway in the north wall has lettered above it, 'ABANDON HOME, ALL YE WHO ENTER HERE.'"

West from the Big Dig is an unimplemented hazy room.
Down from the Big Dig is an unimplemented hazy room.
North from the Big Dig is an unimplemented hazy room.
Up from the Big Dig is an unimplemented hazy room.
Northwest from the Big Dig is an unimplemented hazy room.
Southeast from the Big Dig is an unimplemented hazy room.
Southwest from the Big Dig is an unimplemented hazy room.

Chapter 10 - The Open Chamber (dead end)

Open Chamber is southeast of the Long Hall. "This looks like a fairly quickly dug chamber, designed for various expansions. Many passages have been chipped out of the living rock in all directions. The main tunnel out leads northwest."

An inexplicable keyhole is here. The description is "A keyhole shines, suspended in the middle of the room.[line break]Obvious Actions: enter keyhole". Understand "key" or "hole" as the keyhole.

Instead of entering the keyhole, say "You walk towards the keyhole, but you simply pass through it, unhindered."

South from the Open Chamber is an unimplemented hazy room.
West from the Open Chamber is an unimplemented hazy room.
East from the Open Chamber is an unimplemented hazy room.
North from the Open Chamber is an unimplemented hazy room.
Southeast from the Open Chamber is an unimplemented hazy room.
Northeast from the Open Chamber is an unimplemented hazy room.
Up from the Open Chamber is an unimplemented hazy room.
Down from the Open Chamber is an unimplemented room with printed name "the Cosmic Encounter Realm".

Chapter 11 - The Carousel Room (dead end)

Carousel Room is above the Long Hall. The printed name is "The [']Carousel Room['] Bar & Grill". "Zagat's says, 'The Carousel may not actually spin -- but after a couple cocktails prepared by master mixologist Flanz Loomi, you'll think it does!' This more than makes up for that barb in the local indie weekly declaring, 'Why do they call it the Carousel? Because the men act like small children and the women look like horses.' Goddamn smart-ass Gen-X punks."

Rule for describing an exit to the Carousel Room: say "to the [']Carousel Room[']".

A thing called IF WRITER'S FORUM ground rules is here, fixed in place. The description is "Unmitigated chaos is nice for the Xyzzy Awards, but if we're going to do this right, we need at least a modicum of sanity. So:[paragraph break]* The moderator will let you know when the floor is open for questions. Until then, please confine your discussion to whispers. (Type HELP WHISPER if you don't know how.)[paragraph break]* Anyone who insists on violating this policy will be forcibly removed from the bar. Don't say we didn't warn you."

The Grue Bouncer is a thing in the Carousel Room. The description is "One look at this shadowy figure tells you that it would be a bad idea to cause trouble tonight."

The verbs for interview situations are in the Carousel Room, fixed in place. The description is "A collection of commands you can use during an interview.[line break]Obvious Actions: raise hand, done, cancel".

Hand-raising is an action applying to nothing. Understand "raise hand" as hand-raising when the player is in the Carousel Room. Carry out hand-raising: say "You raise your hand. The speaker will call on you when it is time."

Question-finishing is an action applying to nothing. Understand "done" as question-finishing when the player is in the Carousel Room. Carry out question-finishing: say "OK, acknowledged, you are done."

Question-canceling is an action applying to nothing. Understand "cancel" as question-canceling when the player is in the Carousel Room. Carry out question-canceling: say "Ok, your intent to ask a question has been canceled."

Chapter 12 - The Clay Cube (dead end)

Clay Cube is northwest of the Long Hall. "This room has been molded out of a soft red clay. Whatever person designed this place must have been meticulously insane, because it's in the shape of a perfect cube. A perfectly round passage leads out of the southeast corner of the room."

West from the Clay Cube is an unimplemented hazy room.
Down from the Clay Cube is an unimplemented hazy room.
South from the Clay Cube is an unimplemented hazy room.
Northeast from the Clay Cube is an unimplemented hazy room.
Northwest from the Clay Cube is an unimplemented hazy room.
East from the Clay Cube is an unimplemented hazy room.
Southwest from the Clay Cube is an unimplemented hazy room.

Chapter 13 - The Rocky Room (dead end)

Rocky Room is northeast of the Long Hall. "Piles of granite chips litter the floor here, marking the fact that some super-human strength has carved this room out of the living rock. The main tunnel leads to the southwest."

Down from the Rocky Room is an unimplemented room with printed name "Hell".
Up from the Rocky Room is an unimplemented room with printed name "Ursa Minor Beta".
East from the Rocky Room is an unimplemented hazy room.
South from the Rocky Room is an unimplemented hazy room.
West from the Rocky Room is an unimplemented hazy room.

Chapter 14 - Outside

Outsideland is west of the lounge. The printed name is "Outside". "Ah, the great outdoors! The sun is shining (may not be applicable in some time zones), birds are singing (and not asking for cork nuts), all is right with the world. Two structures dominate this area: a lounge of some sort to the east, and a friendly-looking house to the west. A spur road leads north."

Rule for describing an exit to the lounge when the player is in Outsideland: say "to the lounge".

Rule for describing an exit to MUD Road when the player is in Outsideland: say "up the road".

Chapter 15 - The House (dead end)

Living Room is west of Outsideland. "A sliding door leads west to the backyard, while the kitchen lies north and a staircase leads up. The front door is to the east."

Rule for describing an exit to Living Room: say "to the house".
Rule for describing an exit to Outsideland when the player is in Living Room: say "to the rest of the MUD".

Up from Living Room is an unimplemented room with printed name "the bedroom".
North from Living Room is an unimplemented room with printed name "the kitchen".
West from Living Room is an unimplemented room with printed name "the backyard".

A Britney Spears inflatable chair is here. It is an enterable supporter, fixed in place. The description is "It's clear plastic covered with musical notes. Chill out just like Britney does!"

Instead of taking the Britney Spears inflatable chair, say "It's light enough to pick up, but too cumbersome."

After entering the Britney Spears inflatable chair, say "As you settle into the chair, you briefly wonder if you might not be too sexy too soon."

A piano is here, fixed in place. The description is "You tickle the ivories as much as the next girl..."

Chapter 16 - MUD Road (dead end)

MUD Road is north of Outsideland. "Not a mud road, mind you -- it's actually well-tended gravel. It peters out right about here, though."

Rule for describing an exit to MUD Road: say "to MUD Road".

Rule for describing an exit to Outsideland when the player is in MUD Road: say "down the road".

A sign is here, fixed in place. The description is "It is a large arrow made out of green plastic. It is surrounded with glowing bulbs and is pointing to the north."

North from MUD Road is an unimplemented hazy room.
West from MUD Road is an unimplemented room with printed name "up a set of stone steps into the library".
Southwest from MUD Road is an unimplemented room with printed name "through a ruined archway".
Down from MUD Road is an unimplemented room with printed name "into a small pipe in the ground".
East from MUD Road is an unimplemented room with printed name "to a mystic portal".
Northwest from MUD Road is an unimplemented room with printed name "up the road through the village".
Northeast from MUD Road is an unimplemented room with printed name "to the Napping Room".

[ Let all the exits in this room provide their own prepositions. ]
Rule for describing an exit to an unimplemented room (called R) when the player is in MUD Road: say R.

Chapter 17 - The Toyshop

Toyshop is southwest of the lounge. The printed name is "Toyshop and Floyditorium". "Bulging toychests make this a child's (or child-at-heart's) dream.  Play all day, play all night. A small booth has been erected and is staffed by a friendly robot. The sign over it says, 'INFOKOM GAMEZ 5 cents'.  A small notice on the door reads, 'PLEASE RETURN TOYS TO THIS ROOM WHEN YOU'RE DONE WITH THEM.'".

Rule for describing an exit to the Toyshop: say "to the toyshop".

A green button is here.
A banana machine is here.
Some faucets are here.
A toy catalogue is here. Understand "catalog" as the toy catalogue.
A crystal ball is here.
A cuddly walrus is here.
A clicker is here.
A cloak is here.
A thing called tic-tac-toe is here.
A thermometer is here.
A yellow button is here.
A checkers board is here.
Some Werewolf rules are here.
A bunny burger is here.
A signaling device is here.
Mike Tyson is here.
IF Programmer Barbie is here.
IFDTJ is here. The printed name is "IF FLOYD'S DOWN, TELL JOTA -- OR ELSE HE WON'T KNOW". Understand "if/floyd's/down/tell/jota/or/else/he/won't/know" as IFDTJ.
Some Gak is here.
An Autohugger is here.
A Photocopier is here.
A basketball is here.
A midterm monster is here.
A frobozz magic dispenser is here.
A fun shiny toy is here.
Some madlibs are here.
An orange is here.
A jukebox is here.
A FREE DONUTS machine is here.
A long-stemmed red rose is here.
A thing called dfan's quest is here.
A miniature ifMUD is here.
A Pun Police Whistle is here.
An orange door is here.
A monkey guru is here.
A thing called mind chess is here.
A hey there playerfish cube is here. The printed name is "[']hey there, playerfish!['] cube".
An apple is here.
A zorkmid is here.
A storyharp is here.
Some ClubFloyd Suggestions are here.
A save button is here.
A specimen jar is here.
A soda reading Don't Drink Me is here. The printed name is "soda reading [']Don't drink me![']".
Gene Ray is here.
A jellybean is here.

Section 1 - Floyd

Floyd is a connected person in the toyshop with doing string "waiting for someone to play with me". The description is "From its design, the robot seems to be of the multi-purpose sort. It is slightly cross-eyed, and its mechanical mouth forms a lopsided grin.[line break][bracket]Type READ FLOYD'S INSTRUCTIONS to find out how he works.[close bracket]"

Floyd carries a thing called Instructions On How To Use Floyd. Understand "floyd's instructions" as the instructions. The description of the instructions is "Hi! Floyd is a Bot -- that means he's really a computer program, and not a real person. He's hooked up to an Inform, TADS, and Hugo interpreter, and that means that you can use him to play IF games right from ifMUD! Type [']who['] to see what game Floyd is running (it'll be in the line of text after his name). If he's not running anything, type [']Floyd, list['] to list what games he has available, and [']Floyd, load <game>['] to load a certain game. While the game is running, just type [']Floyd, <command>['] to send a command to the game. (Those are without the [']['] or <> marks, of course.) Have fun!"

Instead of answering Floyd that "list":
	say "Floyd says, 'No games available.'";
	reset idle time for Floyd.

Carry out answering Floyd that:
	if the topic understood includes "load", say "Floyd says, 'Floyd doesn't know that game.'";
	otherwise say "Floyd says, 'Floyd doesn't know that trick.'";
	reset idle time for Floyd.

Chapter 18 - The Spoiler Room

A room called Spoiler Room is southeast of the lounge. "The air is hazy with spoilers and heated from discussions. Don't stay in here unless you're willing to discuss games!"

Rule for describing an exit to the Spoiler Room: say "to the spoiler room".

A notice is here, fixed in place. The description is "Here there be spoilers![paragraph break]Game review objects may be created and dropped here, as long as you @lock them here."

A sign control is here, fixed in place. The description is "You can use this control to change the neon sign alerting loungers what game you're spoiling in here. It is currently set to [if the message of the spoiler room sign is blank]nothing[otherwise][message of the spoiler room sign][end if].[line break]Obvious Actions: set sign to *, clear sign".

To decide whether (T - indexed text) is blank:
	if T is "", decide yes;
	decide no.

Instead of setting the sign control to:
	now the message of the spoiler room sign is the topic understood in title case;
	say "The neon sign has been changed. It now reads: [message of the spoiler room sign]."

Instead of pushing [i.e. clearing] the sign control:
	now the message of the spoiler room sign is "";
	say "You turn off the neon sign."

A thing called a Spoiler is here, fixed in place. The description is "The spoiler occupies the southeast corner of the room and heats the discussions here."

A Boiler is here, fixed in place. The description is "The boiler provides hot water to the ifMud so you can make your tea/coffee/whatever, wash your dishes/clothes/self, and anything else that might require hot water. It is fired by heated discussions, or, when none are available, directly from the spoiler."

A Moiler is here, fixed in place. The description is "This does strange things in the midnight sun, providing a certain amount of solar heat for the boiler when people are asleep and not having heated discussions."

Chapter 19 - Alex's Perch

Alex's Perch is above the lounge. "Luckily, robotic parrots don't need a lot of living space."

Rule for describing an exit to Alex's Perch: say "to Alex's perch".

Rule for describing an exit to the lounge when the player is in Alex's Perch: say "to the lounge".

A cork nut is here.

[TODO: add "inky" exit? probably not.]

Chapter 20 - Alex's Vault (dead end)

Vault is inside from Alex's Perch. "If there is a crisis and the world supply of cork nuts is destroyed, these few, kept in safety, will be enough to respawn the race. Also, sometimes Alex gets hungry at night."

Rule for describing an exit to Vault: say "into a vault".

A Scorched Corknut is here.

Part 3 - ifMUD Characters

Chapter 1 - Bit Players

Wizard is a person.

Tomorrow is a neuter person with real name "Carl Tomenea Nunne". [An anagram for "real announcement".]

[Floyd is simple enough that he's defined in the Toyshop.]

Chapter 2 - Alex

Alex is a connected male animal in the lounge with doing string "This Parrot Plays Games". The real name is "Alex Pepperberg". The description is "Behind that bland avian expression, he's laughing at us.[line break][bracket]To ask Alex about something, try ASK ALEX ABOUT MONKEY or ALEX, MONKEY?[close bracket]".

The temporary text is indexed text that varies.

Carry out answering Alex that:
	let T be indexed text;
	let T be the topic understood;
	if T matches the text " is " or T matches the text " means " begin;
		make Alex learn;
		rule fails;
	end if;
	replace the regular expression "<.?!>$" in T with "";
	change the temporary text to T;
	replace the topic understood with "[the temporary text]";
	make Alex answer the question.

Carry out asking Alex about: make Alex answer the question.
Carry out telling Alex about: make Alex learn.

To make Alex answer the question:
	if the topic understood is a topic listed in the Table of Alex's Responses begin;
		say "Alex says (to Guest), 'Awwwk! Word on the street is that [response entry]'[line break]";
	otherwise if the topic understood is a topic listed in the Table of Alex's Special Responses;
		say "Alex says (to Guest), '[response entry]'[line break]";
	otherwise;
		say "Alex says (to Guest), 'Um, seven?'";
	end if;
	reset idle time for Alex.

To make Alex learn:
	say "Alex says (to Guest), 'Awwwk! No permission!'";
	reset idle time for Alex.

Table of Alex's Special Responses
topic					response
"hi/hello"				"Awwwk! Hi Guest! Did you bring me a cork nut?"
"bye/goodbye" or "good bye"		"Awwk! Bye-bye!"
"yes/yeah/yup/y"				"Awwwk! So where's my cork nut then?"
"almond/corknut" or "cork nut"		"Awwwk! Want cork nut!"
"[any room]"				"Awwwk! Go exploring!"
"[any connected person]"			"Awwwk! Ask them yourself!"
"[any disconnected person]"		"Awwwk! Won't talk behind their back!"

Table of Alex's Responses
topic					response
"alex/you/yourself/himself/bird/parrot"	"Alex is a responsive agent for interactive semi-relational database storage and queries, written in Perl. Also, a general-purpose agent for url storage, conversation logging, inappropriate comment insertion, and cork nut requests."
"me/guest/guests/myself"			"Guest is a gestalt entity. Out of many, one. Well, sometimes we have two. Also, a welcome invader."
"vaporware"				"vaporware is in over his head. Also, vegeware. Also, vapsybobo. Also, software that is promised but never seems to actually appear."
"ifmud/here/mud" or "this/the mud/place"	"ifMUD is A MUD Forever Voyaging. Also, written in Inform 7 now. Also, the only place where you can tell your troubles, and people will make monkey jokes."
"monkey" or "a monkey"			"a monkey is funny. Also, furry. Also, even funnier when wearing a fez. Also, not funny any more, but we still call it funny like we still call the President the President even when he's not."
"fez" or "a fez"				"a fez is funny, especially on a monkey."
"funny/humor"				"funny is monkey. Also, in your parse. Also, pranks are funny. Also, words with a [']k['] are funny."
"april fool/fools/fool's/1/1st" or "april fool/fools/fool's day" or "afd/today/joke/jokes/prank/pranks/gag/hoax/upgrade/convenience" or "this/the joke/prank/gag/hoax/upgrade"	"April Fools Day is April 1st, 2008, the day ifMUD was upgraded for your convenience."
"tomorrow/doing/poll/pollster" or "april 2/2nd"		"tomorrow is April 2nd, 2008. Also, someone who loves anagrams."
"anagram/anagrams/clue/clues/hint/hints/secret/secrets"	"anagram is a rag man. Also, ram-a-nag. Also, scrambled clue, finger who. Also, there are a few of them."
"seven/7"				"Seven is a movie with that dreamboat Brad Pitt. Also, what I say when I haven't understood your sentence."
"markov"				"Markov is a bot who likes monkey abuse. Also, not a parrot. Also, a dead Russian."
"floyd"					"Floyd is yor frend. Also, your plastic pal that's fun to be with. Also, busted."

Alex's referenced person is a person that varies.

Definition: a person is Alex-ref-disconnected:
	if it is connected, no;
	change Alex's referenced person to it;
	yes.

Chapter 3 - Markov

Markov is a connected person in the lounge with doing string "I am the cure for brane". The description is "You see nothing special about Markov.[line break][bracket]To speak with Markov, try TELL MARKOV ABOUT MYSELF or MARKOV, HOW ARE YOU?[close bracket]".

Carry out asking Markov about: make Markov respond.
Carry out telling Markov about: make Markov respond.
Carry out answering Markov that: make Markov respond.

To make Markov respond:
	let nonsense be indexed text;
	let nonsense be "[gibberish starting from initial]";
	replace the regular expression "\s+$" in nonsense with "";
	say "Markov says (to Guest), '[nonsense]'[line break]";
	reset idle time for Markov.

To say gibberish starting from (starting state - an m-state):
	let the current state be the starting state;
	let the possible branches be { initial }; [BUGFIX: "let the possible branches be a list of m-states" doesn't work.]
	let the sentence count be 0;
	while true is true begin;
		let the possible branches be {};
		choose the row with an m-state of the current state in the Table of M-States;
		if there is a first branch entry, add the first branch entry to the possible branches;
		if there is a second branch entry, add the second branch entry to the possible branches;
		if there is a third branch entry, add the third branch entry to the possible branches;
		if there is a quip table entry begin;
			choose a random row in the quip table entry;
			if there is a quip entry, say the quip entry;
			if there is a first branch entry begin;
				let the possible branches be {};
				add the first branch entry to the possible branches;
			end if;
			if there is a second branch entry, add the second branch entry to the possible branches;
			if there is a third branch entry, add the third branch entry to the possible branches;
		end if;
		[ advance to another state ]
		let N be the number of entries in the possible branches;
		if N is 0, stop;
		let N be a random number between 1 and N;
		let the current state be entry N in the possible branches;
		if the current state is pop, stop;
		if the current state is sentence begin;
			now Markov is singularizing;
			increase the sentence count by 1;
			if the sentence count is 4, stop;
		end if;
		if the current state is quote or the current state is tip-clause, now Markov is singularizing;
	end while.

Markov can be pluralizing or singularizing. To say mkp: now Markov is pluralizing. To decide whether mkp: decide on whether or not Markov is pluralizing.

[ Left as an exercise for the reader (heh): figure out why Markov sometimes leaves the tip-end off after a quote, as in: Markov says (to Guest), "Do you mean loose lips say "April Fools Day is them"" ]

M-state is a kind of value. The m-states are initial, greeting, sentence, url, url-site, url-path, url-file, url-query, eliza, tip-starter, tip-clause, tip-inner, tip-qualifier, tip-subject, tip-descriptor, tip-verb, tip-object, tip-end, query-starter, query-subject, query-verb, query-object, query-end, descriptor, another-descriptor, quote, and pop.

Table of M-States
m-state			quip table		first branch	second branch	third branch
initial			--			greeting		sentence	sentence
greeting			Table of Greetings	sentence	--		--
sentence		--			eliza		tip-starter	query-starter
url			Table of URL Starters	url-site		--		--
url-site			Table of URL Sites	url-path		--		--
url-path			Table of URL Paths	url-path		url-file		--
url-file			Table of URL Files	pop		pop		url-query
url-query		Table of URL Queries	pop		--		--
eliza			Table of Elizas		sentence	--		--
tip-starter		Table of Tips		tip-end		--		--
tip-clause		Table of Tip Clauses	tip-end		--		--
tip-inner			Table of Tip Starters	tip-subject	tip-qualifier	--
tip-qualifier		Table of Tip Qualifiers	tip-subject	--		--
tip-subject		Table of Tip Subjects	tip-verb		tip-verb		tip-descriptor
tip-descriptor		Table of Tip Descriptors	tip-verb		tip-verb		tip-descriptor
tip-verb			Table of Tip Verbs	tip-object	--		--
tip-object		Table of Tip Objects	pop		--		--
tip-end			Table of Tip Ends	sentence	--		--
quote			Table of Quotes		pop		--		--
query-starter		Table of Query Starters	query-subject	--		--
query-subject		Table of Tip Subjects	query-verb	--		--
query-verb		Table of Tip Verbs	query-object	--		--
query-object		Table of Tip Objects	query-end	--		--
query-end		Table of Query Ends	sentence	--		--
descriptor		Table of Descriptors	pop		pop		another-descriptor
another-descriptor	Table of One Space	descriptor
pop			--			--		--		--

Table of Greetings
quip
"Hi there. "
"Look. "
"Listen up. "
"Check it out. "
"Thanks. "
"That's funny. "
"Greetings creature. "
"Huh! "
"Heh. "

Table of URL Starters
quip
"http://"

Table of URL Sites
quip
"www.microsoft.com/"
"www.snopes.com/"
"www.hansprestige.com/"
"www.cnn.com/"
"en.wikipedia.org/"
"groups.google.com/"
"www.amazon.co.uk/"
"livejournal.com/"
"www.uncyclopedia.com/"

Table of URL Paths
quip
"public/"
"cgi-bin/"
"e-shop/"
"NR/"
"downloads/"
"wiki/"
"product/"
"users/"
"group/"
"article/"
"2008/"
"04/01/"

Table of URL Files
quip
--
"default.aspx"
"index.html"
"index.htm"
"viewtopic.php"
"checkout.pl"
"whatsnew.html"
"Report2007.pdf"
"customer-reviews"
"Elephant"
"Lost_(TV_show)"
"MUD"
"coming_soon.html"
"AprilFools.jpg"
"eBayISAPI.dll"
"404.shtml"

Table of URL Queries
quip
"?q=monkey+butler"
"/B000BZN38A"
"?hl=en"
"#top"
"#c[a random number between 100 and 30000]"
--
--
--
--
--

Table of Elizas
quip					first branch
--					sentence
--					sentence
--					sentence
--					sentence
--					sentence
"How do you feel about that? "
"Are you a person who [gibberish starting from tip-verb]? "
"I am glad you find this so amusing, Guest. "
"What is the difficulty? "
"Is this an insurmountable obstacle? "
"Hmm, are you serious? "
"Do you mean that? "
"Why do you ask? "
"I haven't heard anything like that before. "
"I hope that's all right. "
"Does that bother you? "
"We can talk about it later. "
"What does that remind you of? "
"You can admit it. "
"Don't worry about it. "
"That hurt my feelings. "
"What do you mean? "
"What does that mean? "
"But that's not all, is it? "
"But [one of]I[or]we[or]you[at random] know what that really means. "
"Is that realistic? "
"Come on. "
"Do you follow me? "
"Does that make sense? "
"Get it? "
"Never mind. "
"That's not important. "
"Please explain. "
"Tell me more. "

Table of Tips
quip
"[gibberish starting from tip-inner]"

Table of Tip Clauses
quip
"[gibberish starting from tip-qualifier]"

Table of Tip Starters
quip										first branch
--
--
--
"I heard "
"You know, "
"You mean "
"Also, "
"Hey, "
"Like "
"But I thought "
"But "
"When "
"As if "
"Suddenly, "
"But I am realizing "
"I don't think you mean "
"It's because "
"Because "
"Then "
"Er, "
"Oh, "
"I mean, "
"[one of]But[or]And[at random] [one of]yes[or]no[at random], "
"However "
"And "
"Thus "
"Sometimes "
"I believe "
"It's just that "
"Thing is, "
"Seriously, "
"Frankly, "
"No offense, but "
"[one of]See[or]Check out[or]You mean[at random] [gibberish starting from url]. "	tip-inner

Table of Tip Qualifiers
quip
"someone told me "
"it's possible that "
"some of "
"maybe "
"it's no good when "
"I love how "
"I'm glad "
"I'm worried that "

Table of Tip Subjects
quip
"your mom "
"Google "
"this "
"that "
"he "
"she "
"they [mkp]"
"the golden age of VoIP "
"physical location "
"Metroid Prime's controls [mkp]"
"April Fools Day "
"owls [mkp]"
"bats [mkp]"
"the Monkees [mkp]"
"the Violent Femmes [mkp]"
"Spoon "
"Rocky Horror "
"classical music "
"Pepsi products [mkp]"
"loose lips [mkp]"
"medical waste "
"my backpack "
"the meaning of life "
"this place "
"today "
"you [mkp]"
"a squirrel "
"the weighted companion cube "
"children of the gold standard [mkp]"
"the mayor "
"Graham "
"Miyamoto "
"Tom Cruise "
"Tim Curry "

Table of Tip Descriptors
quip
"[gibberish starting from descriptor] "

Table of Descriptors
quip
"who [mkis] [gibberish starting from tip-object]"
"and [gibberish starting from tip-object][mkp]"
"with [gibberish starting from tip-object][mkp]"
"and [one of]her[or]his[at random] friends[mkp]"
"all"
"finally"
"always"
"never"
"from the show"
"again"
"and I[mkp]"
"as you know"
"in turn"
"out of nowhere"
"sort of"
"somehow"
"or whatever"

Table of One Space
quip
" "

To say mkis: if mkp, say "are"; otherwise say "is".
To say mks: if not mkp, say "s".
To say mkes: if not mkp, say "es".
To say mkhas: if mkp, say "have"; otherwise say "has".

Table of Tip Verbs
quip					first branch
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[mkis] "
"[if mkp]were[otherwise]was[end if] "
"[if mkp]were[otherwise]was[end if] "
"[mkhas] "
"like[mks] "
"go[mkes] "
"go[mkes] to "
"really matter[mks] for "
"[mkhas] got "
"got "
"can't have "
"couldn't be "
"won't be "
"won't go "
"do[mkes]n't fit in "
"go[mkes] with "
"do[mkes]n't know about "
"heard from "
"sent me "
"shut down "
"played "
"hijacked "
"take[mks] "
"trust[mks] "
"[mkhas]n't been "
"[mkhas]n't used "
"taste[mks] like "
"look[mks] like "
"[one of]said[or]say[mks][at random] "	quote
"[one of]told[or]tell[mks][at random] [one of]him[or]her[or]me[or]you[or]us[or]them[at random], "		quote

Table of Tip Objects
quip
"funny"
"shopping"
"a puppy"
"a lame trick"
"an economy class starship"
"irrelevant"
"Eastern europeans"
"Ralph Nader"
"some combat"
"insane cliffhangers"
"at [gibberish starting from url]"
"him"
"her"
"them"
"that"
"a podcast"
"terrible"
"a free copy of vista"
"trash compactors on the detention level"
"jets"
"a submarine"
"a Winnebago"
"clown shoes"
"the weak sauce"
"belong to us"
"tea"
"some tea"
"42"
"more gas"
"transforming robots"
"the mayor's office"
"a high screen tv"
"a simple one-step process"
"holograms"
"a hoax"
"waiting for tomorrow"
"old enough"
"good enough"
"smart enough"
"crazy"
"cheap"
"hidden"
"laughing"
"hilarious"
"playing along"
"caving in"
"looking for an opportunity"
"tricking [one of]you[or]me[at random]"
"smuggling plums"
"so hot right now"
"out this season"
"a bonsai kitten"
"a skyhook"
"striped paint"
"written in RAIF-POOL"
"almost ready"

Table of Tip Ends
quip					first branch
". "
". "
". "
". "
". "
". "
". "
". "
". "
". "
"? "
"! "
" anyway? "
"... in bed. "
"... "
", usually. "
" tonight. "
" this year. "
" online. "
", though. "
", if you know what I mean. "
" AMATNG. "
" too. "
": "					tip-clause
", and "					tip-clause
", but "					tip-clause
", or "					tip-clause
", and then "				tip-clause
" even though "				tip-clause
", although "				tip-clause
"; however, "				tip-clause

Table of Quotes
quip
"'[gibberish starting from tip-subject]'"

Table of Query Starters
quip
"Why does [mkp]"
"Why did [mkp]"
"When will [mkp]"
"When did [mkp]"
"How can [mkp]"
"How would [mkp]"
"What if "
"What about when "
"Remember when "
"Did you know "
"Do you mean "
"What, "
"How long until "
"What happens when "

Table of Query Ends
quip
"? "
"? "
"? "
"? "
"?? "
" at all? "
", huh? "
", anyway? "
" or not? "
"...? "
" today? "
" last night? "

Chapter 4 - The ifMUD Community

A mudder is a kind of person.

Instead of examining when the noun is the player or the noun is a mudder:
	say "[The noun] is a player. Idle time: [if the noun is the player]00m00[otherwise][idle time of the noun as a short time][end if]. Connected: [connection time of the noun as a short time]."

Jota, inky, vaporware, ctate, Storme, Iain, Jacqueline, Emily, boucher, Limax, Allen, jess, Matthew, BrenBarn, Duchess, Roger, Nate, Bishop, DorianX, schep, baf, DavidW, Lionheart, two-star, ghira, josh_g, lpsmith, Fink-Nottle, Jon, Dave, vimes, Jaybird, zarf, and trikiw are mudders.

nothings_ is a mudder with printed name "nothings". Understand "nothings" as nothings_.

A mudder is usually male. Storme, Jacqueline, Emily, jess, and Duchess are female.

A mudder can be zoned, chilling, conversing, wandering, or arriving. A mudder is usually chilling.

Definition: a mudder is responsive if it is not zoned.

A mudder can be active or passive. A mudder is usually active. [To prevent mudder actions from occurring for mudders who've already responded to an action that turn.]

A persuasion rule:
	say "You can't order other players.";
	persuasion fails.

This is the mudder engine rule:
	repeat with M running through connected mudders begin;
		consider the mudder action rules for M;
	end repeat;
	now every mudder is active;
	consider the mudder event rules.

[The mudder engine runs after each input and action, giving the mudders a chance to say something before and after the output from every successful command.]
Every input: consider the mudder engine rule.
Every turn: consider the mudder engine rule.

Section 1 - The Party Already Started

When play begins:
	let up-hours be the mud uptime divided by 240;
	let the desired mudder count be up-hours times 2;
	let the available mudder count be the number of disconnected mudders;
	if the desired mudder count is at least the available mudder count, let the desired mudder count be 10;
	repeat with N running from 1 to the desired mudder count begin;
		let P be a random disconnected mudder;
		now P is connected;
		[ set a doing string ]
		select a doing string for P;
		[ set an activity and the appropriate connection/idle times ]
		if a random chance of 1 in 3 succeeds begin;
			now P is zoned;
			now P is in the lounge;
			change the connection time of P to a random number between 240 and the mud uptime;
			change the idle time of P to a random number between 240 and the connection time of P;
		otherwise if a random chance of 1 in 10 succeeds;
			now P is wandering;
			now P is in a random reachable room which is not the lounge;
			change the connection time of P to a random number between 10 and the mud uptime;
			change the idle time of P to a random number between 0 and 239;
		otherwise if a random chance of 1 in 2 succeeds;
			now P is in the lounge;
			now P is conversing;
			change the connection time of P to a random number between 10 and the mud uptime;
			change the idle time of P to a random number between 0 and 8;
		otherwise;
			now P is in the lounge;
			now P is chilling;
			change the connection time of P to a random number between 10 and the mud uptime;
			change the idle time of P to a random number between 0 and 239;
		end if;
	end repeat.

Definition: a room is reachable if a room is adjacent to it.

To select a doing string for (P - person):
	if the doing string of P is "" and the number of filled rows in the Table of Stock Doings is at least 1 and a random chance of 5 in 6 succeeds begin;
		choose a random row in the Table of Stock Doings;
		change the doing string of P to the quip entry;
		blank out the whole row;
	end if.

Table of Stock Doings
quip
"a man a plan a canal panama"
"Oh, what a to-do to die today!"
"Amidst the mists and fiercest frosts..."
"it was a dark and stormy night"
"it was the best of times, it was the worst of"
"eating the breakfast of champions"
"What's all this, then?"
"No thanks. Take me off the list."
"a submarine? at this hour?"
"but what about the others"
"hey pal, I got your doing right here!"
"05m78"
"I've got one from Spain and two from Nepal"
"shaken by the saints river"
"as I lay silent I can hear you speak"
"What do I type here?"
"..."
"mah nah mah nah"
"tax forms, mostly"
"not amused"
"spork spork spork"

To say hello from (observer - person) to (newbie - person):
	say "[observer] says, '[one of]hey[or]hi[or]Hey,[or]Hi,[or]speaking of [random subject], it's[as decreasingly likely outcomes] [newbie][if a random chance of 1 in 5 succeeds]![no line break][otherwise].[no line break][end if]'[line break]";
	reset idle time for the observer;
	now the observer is passive.

To say random subject:
	say "[one of]monkey butlers[or]insane clown posses[or]chicken stew alliances[or]picking up the phone booth[or]timely arrivals[at random]".

To say hello from (newbie - person) to everyone:
	say "[newbie] says, '[one of]heya[or]hi[or]hello[or]ahoy[or]yo[at random].'";
	now the newbie is passive;
	reset idle time for the newbie.

To say goodbye from (observer - person) to (goner - person):
	say "[observer] says (to [goner]), '[one of]bye[or]later[or]see ya[at random].'";
	now the observer is passive;
	reset idle time for the observer.

To say goodbye from (goner - person) to everyone:
	say "[goner] says, '[one of]Goodbye[or]bye[or]csb[or]back later[or]good night[at random].'";
	now the goner is passive;
	reset idle time for the goner.

Every turn when traveling and a random chance of 1 in 2 succeeds:
	let the observer be a random active mudder who can see the player;
	if the observer is a mudder, say hello from the observer to the player.

Section 2 - Mudder Events

[The mudder event rules cause mudders to change state: connecting or disconnecting, or picking up a different activity. These events only affect one mudder at a time.]

The mudder event rules are a rulebook.

A mudder event rule when fewer than 20 mudders are connected (this is the make mudder connect rule):
	if a random chance of 1 in 10 succeeds begin;
		let the newbie be a random disconnected mudder;
		now the newbie is connected;
		now the newbie is arriving;
		now the newbie is in Dorm A;
		change the connection time of the newbie to 0;
		reset idle time for the newbie;
		select a doing string for the newbie;
		say run paragraph on;
		say "<[newbie]> [newbie] has connected to ifMUD.";
		if the player can see the newbie, say "[newbie] has connected.";
		rule succeeds;
	end if.

A mudder event rule when at least two mudders are connected (this is the make mudder disconnect rule):
	if a random chance of 1 in 20 succeeds begin;
		say run paragraph on;
		let the goner be a random connected mudder;
		if the player can see the goner begin;
			say goodbye from the goner to everyone;
			let the observer be a random active mudder who observes the goner;
			if the observer is a mudder and a random chance of 1 in 2 succeeds, say goodbye from the observer to the goner;
			say "[goner] goes home.";
		end if;
		now the goner is disconnected;
		remove the goner from play;
		say "</[goner]> [goner] has disconnected from ifMUD.";
		rule succeeds;
	end if.

Section 3 - Mudder Actions

[The mudder action rules govern what each mudder does, every turn, depending on its state.]

The mudder action rules are an object-based rulebook. The mudder action rules have default success.

The first mudder action rule for passive mudders: rule succeeds. [They've already acted this turn.]

A mudder action rule for a wandering mudder (called the wanderer):
	if a random chance of 1 in 2 succeeds begin;
		let the current place be the location of the wanderer;
		let the destination be a random room adjacent to the current place;
		let thataway be the best route from the current place to the destination;
		try the wanderer going thataway;
		reset idle time for the wanderer;
	end if;
	if at least five connected people are in the location of the wanderer, now the wanderer is conversing.

A mudder action rule for an arriving mudder (called the newbie):
	if the newbie is in the lounge begin;
		if the player can see the newbie begin;
			if a random chance of 1 in 2 succeeds, say hello from the newbie to everyone;
			let the observer be a random active mudder who observes the newbie;
			if the observer is a mudder and a random chance of 1 in 2 succeeds, say hello from the observer to the newbie;
		end if;
		if a random chance of 1 in 2 succeeds, now the newbie is chilling;
		otherwise now the newbie is conversing;
	otherwise;
		let thataway be the best route from the location of the newbie to the lounge;
		try the newbie going thataway;
		reset idle time for the newbie;
	end if.

A mudder action rule for a conversing mudder (called the speaker):
	if the player can see the speaker and a random chance of 1 in 6 succeeds begin;
		let flavor be a random quip flavor;
		if flavor is inflammatory, let flavor be a random quip flavor;
		let the observer be a random active mudder who observes the speaker;
		if flavor is funny and a random chance of 1 in 8 succeeds and the observer is a mudder, say "(from [speaker]) [random active mudder who observes the speaker]";
		otherwise say "[speaker]";
		say " says, '[a random flavor quip]'[line break]";
		reset idle time for the speaker;
		if the observer is a mudder and (flavor is inflammatory or a random chance of 1 in 2 succeeds) begin;
			say "[observer] says (to [speaker]), '";
			if flavor is inflammatory or a random chance of 5 in 6 succeeds, say a random response to a flavor quip;
			otherwise say a random flavor quip;
			say "'[line break]";
			reset idle time for the observer;
			now the observer is passive;
			now the observer is conversing;
		end if;
	end if;
	if a random chance of 1 in 5 succeeds, now the speaker is chilling.

Observation relates a person (called X) to a person (called Y) when X is not Y and X can see Y. The verb to observe (it observes, they observe, it is observing, it is observed) implies the observation relation.

A mudder action rule for a zoned mudder (called the snoozer):
	if a random chance of 1 in 25 succeeds, now the snoozer is chilling.

A mudder action rule for a chilling mudder (called the chiller):
	let N be a random number between 1 and 100;
	if N < 10, now the chiller is zoned;
	if N > 10 and N < 20, now the chiller is wandering;
	if N > 75, now the chiller is conversing.

Section 4 - Mudder Quips

Quip flavor is a kind of value. The quip flavors are funny, sad, exciting, interesting, inflammatory, and inquisitive.

Carry out asking a mudder about when a random chance of 2 in 3 succeeds:
	provoke an inquisitive response from the noun.

Carry out telling a mudder about when a random chance of 2 in 3 succeeds:
	provoke an interesting response from the noun.

Carry out answering a mudder that when a random chance of 2 in 3 succeeds:
	provoke a random response from the noun.

[ Random banter ]

To provoke a random response from (speaker - mudder):
	let flavor be a random quip flavor;
	if flavor is inflammatory, let flavor be a random quip flavor;
	provoke a flavor response from the speaker.

To provoke a/an (flavor - quip flavor) response from (speaker - mudder):
	say "[speaker] says (to [the player]), ";
	if flavor is not inquisitive and a random chance of 2 in 3 succeeds, say "'[a random flavor quip]'";
	otherwise say "'[a random response to a flavor quip]'";
	say line break;
	now the speaker is passive;
	now the speaker is conversing;
	reset idle time for the speaker.

To say a random (flavor - funny) quip:
	let N be a random number between 1 and 9;
	if N is 1, say "A THOR-LIKE BLOW![no line break]";
	if N is 2, say "so I said, [']supercollider? I just met her.['] and then they built the supercollider.[no line break]";
	if N is 3, say "no soap. radio?[no line break]";
	if N is 4, say "monkey";
	if N is 5, say "hey, did somebody order A LARGE HAM?[no line break]";
	if N is 6, say "[one of]you[or]I[purely at random] smashed that [one of]sandwich[or]bagel[or]muffin[or]banana[or]crumpet[or]yogurt[at random] into ATOMS![no line break]";
	if N is 7, say "what's the difference between a duck?[no line break]";
	if N is 8, say "one of its legs are both the same![no line break]";
	if N is 9, say "so I says, [']that's not what I ordered, but I'll take it anyway!['][no line break]".

To say a random response to a (flavor - funny) quip:
	let N be a random number between 1 and 7;
	if N is 1, say "ha";
	if N is 2, say "ha ha";
	if N is 3, say "ha ha ha";
	if N is 4, say "hee";
	if N is 5, say "yay";
	if N is 6, say "hee hee";
	if N is 7, say "ha![no line break]".

To say a random (flavor - sad) quip:
	let N be a random number between 1 and 8;
	if N is 1, say "I lost my keys";
	if N is 2, say "today [one of]sucked[or]has been confusing[or]has been disappointing[or]everyone's been talking about cool stuff, but it's probably fake[at random].[no line break]";
	if N is 3, say "someone cut me off in the parking lot.[no line break]";
	if N is 4, say "I think my [one of]hard drive[or]keyboard[or]fan[at random][']s dying.[no line break]";
	if N is 5, say "this place [one of]just isn't the same lately[or]seems different lately[or]has changed[at random], you know?[no line break]";
	if N is 6, say "I heard they're going to cancel [one of]The Simpsons[or]House[or]Jeopardy[or]The View[or]Lost[or]Heroes[at random]";
	if N is 7, say "I found [one of]a hairy spider[or]a mouse[or]a cockroach[or]an ant colony[or]termites[or]a hobo[or]a family of bats[or]a cougar[at random] in my [one of]kitchen[or]bathroom[or]garage[or]basement[or]attic[or]pantry[or]closet[at random]";
	if N is 8, say "[one of]turns out[or]the doctor says[or]this commercial makes me think[at random] I might have [one of]achy breaky pelvis[or]two separate feet syndrome (2SF)[or]cobbles[or]a nanobot infection[or]disco fever[at random]".

To say a random response to a (flavor - sad) quip:
	let N be a random number between 1 and 4;
	if N is 1, say "ouch";
	if N is 2, say "aww";
	if N is 3, say "ack";
	if N is 4, say "that bites".

To say a random (flavor - exciting) quip:
	let N be a random number between 1 and 3;
	if N is 1, say "[one of]whoa, [or]hey, [or]oh hey, [or]huh! [or][at random][one of]this email says[or]I got a letter saying[or]this guy on TV said[or]this banner ad says[at random] I [one of]won the UK national lottery[or]won a free iPod[or]may already be a winner[or]get 10% of this Nigerian prince's money[or]can speed up my computer 200%[or]qualify for a free sample[at random]![no line break]";
	if N is 2, say "[one of]so I was[or]this morning I was[or]I'm going to be[or]I might be[or]my cousin was[at random] interviewed for [one of]the Rolling Stone[or]the New York Times[or]the Onion[or]Time[or]Newsweek[or]SPAG[at random].[no line break]";
	if N is 3, say "turns out my [one of]baseball card[or]stamp[or]Beanie Baby[or]penny[or]Pez dispenser[or]comic book[or]lampshade[or]insect[or]8-track[at random] collection [one of]is[or]might be[or]was[at random] worth a fortune...[no line break]";

To say a random response to a (flavor - exciting) quip:
	let N be a random number between 1 and 4;
	if N is 1, say "whoa![no line break]";
	if N is 2, say "really?[no line break]";
	if N is 3, say "no way![no line break]";
	if N is 4, say "awesome![no line break]".

To say a random (flavor - interesting) quip:
	let N be a random number between 1 and 6;
	if N is 1, say "huh, wikipedia says [one of]octopus pants have eight legs[or]porcelain is edible[or]bees can talk[or]the 20th century actually ended in 1997[or]turtles are actually insects[or]JPEG compression was invented by the Romans[at random].[no line break]";
	if N is 2, say "I heard about a way to make [one of]gasoline[or]diamonds[or]lasers[at random] out of [one of]rubber bands[or]paperclips[or]empty cans[at random] and [one of]old soup[or]coffee grounds[or]spoiled milk[or]banana peels[at random].[no line break]";
	if N is 3, say "so I guess they just proved P [one of]=[or]!=[at random] NP.[no line break]";
	if N is 4, say "did you hear they found life on [one of]Mars[or]Venus[or]Neptune[at random]?[no line break]";
	if N is 5, say "[if an implemented room is unvisited]I heard there's candy in [random unvisited implemented room][otherwise]I guess the candy was a lie[end if]";
	if N is 6, say "[if an implemented room is unvisited][one of]I saw a[or]there's a[or]check out the[at random] [one of]glitch[or]bug[or]typo[at random] in [random unvisited implemented room][otherwise]this guest sure has been wandering around a lot[end if]"

To say a random response to a (flavor - interesting) quip:
	let N be a random number between 1 and 3;
	if N is 1, say "huh.[no line break]";
	if N is 2, say "interesting![no line break]";
	if N is 3, say "[one of]yeah, [or]oh, [or]oh yeah, [or][at random][one of]I was just reading about that[or][a random disconnected mudder] [one of]mentioned[or]was talking about[or]said something about[at random] that[one of] earlier[or] last night[or] yesterday[or][at random][at random].[no line break]".

To say a random (flavor - inflammatory) quip:
	let N be a random number between 1 and 3;
	if N is 1, say "you guys like [one of]Fall Out Boy[or]Modest Mouse[or]Baby Geniuses[at random], right?[no line break]";
	if N is 2, say "mind if I invite my friend [one of]Jacek[or]Paul[or]Howard[at random]?[no line break]";
	if N is 3, say "[one of]man[or]dude[or]whoa[at random], [one of]vi[or]emacs[or]the new mud[or]your favorite sports team[at random] sucks.[no line break]".

To say a random response to a (flavor - inflammatory) quip:
	let N be a random number between 1 and 5;
	if N is 1, say "them's fightin['] words![no line break]";
	if N is 2, say "you can't be serious![no line break]";
	if N is 3, say "uh.[no line break]";
	if N is 4, say "omfg you did not just say that.[no line break]";
	if N is 5, say "wtf?[no line break]".

To say a random (flavor - inquisitive) quip:
	let N be a random number between 1 and 7;
	if N is 1, say "anyone know a good [one of]barber[or]restaurant[or]hotel[at random] in [one of]topeka[or]boise[or]el paso[or]jacksonville[or]cairo[or]green bay[or]south bend[at random]?[no line break]";
	if N is 2, say "anyone remember that site [a random disconnected mudder] was talking about?[no line break]";
	if N is 3, say "so, anything going on [one of]tonight[or]this evening[or]tomorrow[at random]?[no line break]";
	if N is 4, say "anyone good at solving anagrams?[no line break]";
	if N is 5, say "[one of]is there a way to[or]can we[or]can you[or]is there some way to[or]can we somehow[at random] [one of]chat[or]converse[or]speak[or]talk[at random] without [one of]typing[or]having to type[or]putting[or]having to put[or]having to say[at random] [one of]EVERYONE[or]'everyone'[or]a player name[or]someone's name[at random] first?[no line break]";
	if N is 6, say "who is [one of]Stan[or]this Stan guy[or]Stan Juprak[at random], anyway?[no line break]";
	if N is 7, say "who [one of]set this[or]keeps changing the[or]changed the[at random] poll?[no line break]"

To say a random response to a (flavor - inquisitive) quip:
	let N be a random number between 1 and 7;
	if N is 1, say "no, sorry";
	if N is 2, say "nope";
	if N is 3, say "yeah";
	if N is 4, say "[a random disconnected mudder] might know";
	if N is 5, say "hmm, hang on";
	if N is 6, say "I'm not sure";
	if N is 7, say "dunno".

Section 5 - Mudder Debugging (not for release)

Debugging mudders is an action applying to nothing. Understand "mudders" or "dm" as debugging mudders.

Carry out debugging mudders:
	repeat with M running through connected mudders begin;
		say "[M]: [mudder condition of M], in [location of M].";
	end repeat.

Chapter 5 - Stan(ton) Juprak Himself

Stan's Office is a room. "The walls are covered with printouts of Inform 7 code and photographs of familiar ifMUD locations. The only exit is through a glowing portal on the south wall."

Some printouts are scenery in Stan's Office. Understand "printout" or "inform/i7" or "inform 7" or "code" as the printouts. The description is "The code appears to describe areas you haven't seen yet."

Some photographs are scenery in Stan's Office. Understand "photo" or "photos" or "photograph" or "picture" or "pictures" or "familiar" or "locations" as the photographs. The description is "Most of the photos depict the lounge and surrounding areas. There are also close-ups of Alex and Markov, and a large group shot of a few dozen mudders. Each photo is covered with indentation lines, as if it's been traced over with a heavy hand."

The glowing portal is scenery in Stan's Office. The description is "You can't see what's on the other side." Instead of going south in Stan's Office, try entering the glowing portal. Entering the glowing portal is traveling.

Instead of entering the glowing portal:
	say "You step through the portal and quickly materialize in...";
	now the player is in the lounge.

A digital clock is here, fixed in place.

Instead of examining the digital clock:
	if the real time clock is available begin;
		let RT be the real time in quarts;
		let quarts be 5760 minus RT;	[5760 quarts = 24 hours]
		let minutes be quarts divided by 4;
		let quarts be the remainder after dividing quarts by 4;
		let hours be minutes divided by 60;
		let minutes be the remainder after dividing minutes by 60;
		let seconds be quarts times 15;
		say "The clock is counting backwards, and it currently reads [hours as two digits]:[minutes as two digits]:[seconds as two digits].";
		if we have not examined the digital clock, say "[line break](Oddly enough, the seconds aren't shown with a normal LCD display, but with four separate indicators. This clock only shows the time to the nearest 15 seconds.)";
	otherwise;
		say "The clock is flashing 12:00:00.";
	end if;
	rule succeeds.

Stan is a connected man in Stan's Office with real name "Stanton Juprak" and doing string "Welcoming you to the new ifMUD!".

When play begins:
	change the connection time of Stan to the mud uptime;
	change the idle time of Stan to a random number between 1 and the connection time of Stan.

Section 1 - Stan's Introduction

Stan's Introduction is a scene. Stan's Introduction begins when most of the implemented rooms are visited. Stan's Introduction ends when Stan is not in Stan's Office.

[Debugging:
Teleporting to Stan's Office is an action applying to nothing. Understand "xxoffice" as teleporting to Stan's Office. Carry out teleporting to Stan's Office:
	now the player is in Stan's Office;
	while the number of visited implemented rooms is less than (the number of implemented rooms / 2), now a random unvisited implemented room is visited.
]

When Stan's Introduction begins:
	say "Stan pages: Hi Guest! How are you enjoying the MUD?";
	reset idle time for Stan;
	Stan apologizes in two turns from now.

At the time when Stan apologizes:
	say "Stan pages: Heh, I forgot guests can't page. I've been meaning to fix that. Let me teleport you here and we can talk...";
	reset idle time for Stan;
	Stan invites the player in 0 turns from now.

At the time when Stan invites the player:
	now the player is in Stan's Office;
	reset idle time for Stan;
	Stan introduces himself in 0 turns from now.

At the time when Stan introduces himself:
	say "Stan says (to Guest), 'Sorry about that. I'm Stan Juprak, the administrator here. This will just take a minute.'";
	reset idle time for Stan;
	Stan mentions the treasure in 0 turns from now.

Stan's Travel Restriction is a scene. Stan's Travel Restriction begins when the player is in Stan's Office. Stan's Travel Restriction ends when Stan's Mission begins.

Instead of traveling during Stan's Travel Restriction:
	say "An administrator has stuck you in place."

Instead of entering the glowing portal during Stan's Travel Restriction:
	say "The portal flickers red and blocks your passage."

A treasure is a kind of thing. The shaggy dog is a treasure with description "This is the second shaggiest dog you've ever seen." The scrying sphere is a treasure with description "This sphere looks like it'd be perfect for any kind of scrying." The bit bucket is a treasure with description "It's just barely big enough to hold a single bit." The administrative sword is a treasure with description "It's enchanted with the power to cut through red tape."

At the time when Stan mentions the treasure:
	let the item be a random treasure;
	now the item is in a random unvisited implemented room;
	say "Stan says, 'Anyway, thanks for checking out the MUD on release day. I see you've been exploring. You haven't come across [an item], have you?'";
	reset idle time for Stan;
	Stan explains the mission in 0 turns from now.

At the time when Stan explains the mission:
	say "Stan says, 'I think one of the other players moved it. If you see it, could you bring it to me? I'll be in Dorm A.'";
	reset idle time for Stan;
	Stan leaves in 0 turns from now.

At the time when Stan leaves:
	now Stan is in Dorm A;
	say "Stan says (to Guest), 'Thanks for your help!'[line break]Stan has left.";
	reset idle time for Stan;
	consider the scene changing rules.

Section 2 - Stan's Mission

Stan's Mission is a scene. Stan's Mission begins when Stan's Introduction ends. Stan's Mission ends when Stan is carrying a treasure.

Instead of showing something to Stan, try giving the noun to Stan.

Procedural rule when giving something to Stan during Stan's Mission: ignore the block giving rule.

Every turn when dropping a treasure in the presence of Stan: try Stan taking the noun.

Every turn when going to Dorm A and the player is carrying a treasure (called the item) during Stan's Mission: make Stan notice the item.
Every turn when teleporting home and the player is carrying a treasure (called the item) during Stan's Mission: make Stan notice the item.

To make Stan notice (item - a treasure):
	say "Stan's eyes light up as he sees you carrying [the item].";
	reset idle time for Stan.

Instead of giving something which is not a treasure to Stan during Stan's Mission:
	say "Stan says, 'That's not what I'm looking for. Bring me [the random on-stage treasure], please.'";
	reset idle time for Stan.

Carry out asking Stan about: make Stan respond.
Carry out answering Stan that: make Stan respond.
Carry out telling Stan about: make Stan respond.

To make Stan respond:
	if the topic understood is a topic listed in the Table of Stan's Responses begin;
		say "Stan says (to Guest), '[quip entry]'[line break]";
	otherwise;
		say "Stan says (to Guest), '[one of]Huh.[no line break][or]Is that so?[no line break][or]I see.[no line break][or]Glad you're having fun.[no line break][at random]'[line break]";
	end if;
	reset idle time for Stan.

Table of Stan's Responses
topic						quip
"treasure/item/thing/quest/mission"		"[Stan's response about the mission]"
"[any treasure]"					"[Stan's response about the mission]"
"ifmud/mud/guncho/here" or "this place/mud/game"	"Pretty cool, huh?"
"hoax/joke/prank" or "april fools/fool's day" or "april fools/fool's/1/1st/first"	"Oh, I guess today is April 1st. Just a coincidence, I assure you."
"tomorrow" or "announcement" or "real announcement"	"Something's going on tomorrow? I guess we'll see."
"anagram/anagrams" or "puzzle/puzzles"		"Aren't anagrams fun?"
"alex/markov/floyd/bot/bots"			"The bots seem a little weird lately, but that's out of my hands. They connect like any other player, you know."
"himself/stan/stanton/juprak" or "stan/stanton juprak"	"My name's Stanton Juprak, but you can call me Stan. I'm kind of a lurker. This is the first IF thing I've ever done. Not bad, right?"
"account" or "an account" or "getting an account"	"I have to go soon... if you hurry maybe I can get you an account today."

To say Stan's response about the mission:
	if a treasure (called the item) is on-stage, say "Please bring me [the item].[no line break]";
	otherwise say "I'm getting to that.[no line break]".

When Stan's Mission ends:
	say "Stan says, 'Hey, thanks! Just for that, I'm going to make you a wizard.'";
	reset idle time for Stan;
	end the game in victory.

Rule for amusing a victorious player:
	say "Did you try...[paragraph break]... talking to Markov?[line break]... typing WHO a few times?[line break]... FINGERing the pollster?[line break]... examining Stan's clock?"
